@Echo Off

REM  --------------------------------------------------------------
REM    This batch file reboots the system under MS-DOS 5.0.  It
REM    performs the following steps:
REM
REM             1.  Checks to see if we're already under MS-DOS,
REM                 and aborts if we are.
REM             2.  Copies the current CONFIG.SYS and AUTOEXEC.BAT
REM                 files to the DR-DOS area in case they have been
REM                 modified recently.
REM             3.  Copies the CONFIG.SYS and AUTOEXEC.BAT files
REM                 from the MS-DOS area to the root directory.
REM             4.  Copies COMMAND.COM from the MS-DOS directory.
REM             5.  Writes the MS-DOS boot sector.
REM   CHANGE -> 6.  Calls our disk cache to flush the buffers.
REM             7.  Warmboots the machine.
REM
REM  --------------------------------------------------------------

BootSect is_msdos
if errorlevel 2 goto Critical_Error
if errorlevel 1 goto Under_MSDos

:Under_DRDos

    echo.
    echo ----------------------------------------
    echo Setting up system to boot MS-DOS v5.0...
    echo ----------------------------------------
    echo.
    copy c:\config.sys c:\boots\dr\*.*
    copy c:\autoexec.bat c:\boots\dr\*.*
    copy c:\boots\ms\*.* c:\
    copy c:\dos50\command.com c:\
    bootsect write c:\boots\boot.ms

REM  -------------------------------------------------------
REM  :::   CHANGE THIS NEXT LINE!
REM  :::
REM  :::   If you use a disk cache with "staged writes",
REM  :::   change this line to call your cache to tell it
REM  :::   to "flush its buffers" to disk.  If you are
REM  :::   using a disk cache that doesn't do staged writes,
REM  :::   merely delete this next line.
REM  -------------------------------------------------------

    d:\caches\hyper\hyperdk D >NUL

    warmboot

:Under_MSDos

    echo.
    echo You're already running MS-DOS!
    goto exit


:Critical_Error

    echo.
    echo A critical error has occurred reading drive C:!

:Exit
